//+------------------------------------------------------------------+

#property copyright "Copyright  2011, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  Red
#property indicator_color2  Blue
#property indicator_color3  Green
#property indicator_style3  STYLE_DOT
#property indicator_color4  Brown
#property indicator_style4  STYLE_DOT
#property indicator_color5  Lavender
#property indicator_color6  Green
#property indicator_style6  STYLE_DOT
#property indicator_color7  Brown
#property indicator_style7  STYLE_DOT

//
//
//
//
//

extern string TimeFrame                    = "Current time frame";
extern int    Tenkan                       = 9;
extern int    Kijun                        = 26;
extern int    Senkou                       = 52;
extern int    ChinkouShift                 = -26;
extern double SmoothLength                 = 10;
extern double SmoothPhase                  = 0;
extern bool   SmoothDouble                 = false;
extern bool   Interpolate                  = true;

extern bool   alertsOn                     = true;
extern bool   alertsOnTenkanKijunCross     = true;
extern bool   alertsOnChinkouPriceCross    = true;
extern bool   alertsOnBothAboveCross       = true;
extern bool   alertsOnKijunKumoCloudCross  = true;
extern bool   alertsOnTenkanKumoCloudCross = true;
extern bool   alertsOnCurrent              = false;
extern bool   alertsMessage                = true;
extern bool   alertsSound                  = true;
extern bool   alertsEmail                  = false;

//
//
//
//
//

double Tenkan_Buffer[];
double Kijun_Buffer[];
double SpanA_Buffer[];
double SpanB_Buffer[];
double Chinkou_Buffer[];
double SpanA2_Buffer[];
double SpanB2_Buffer[];
double trends[][5];

#define _tup1 0
#define _tup2 1
#define _tmi  2
#define _tdn1 3
#define _tdn2 4

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//
//
//
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   
   SetIndexBuffer(0,Tenkan_Buffer);                                  SetIndexLabel(0,"Tenkan Sen");
   SetIndexBuffer(1,Kijun_Buffer);                                   SetIndexLabel(1,"Kijun Sen");
   SetIndexBuffer(2,SpanA_Buffer);  SetIndexStyle(2,DRAW_HISTOGRAM); 
   SetIndexBuffer(3,SpanB_Buffer);  SetIndexStyle(3,DRAW_HISTOGRAM); 
   SetIndexBuffer(4,Chinkou_Buffer);                                 SetIndexLabel(4,"Chinkou Span");
   SetIndexBuffer(5,SpanA2_Buffer);                                  SetIndexLabel(5,"Senkou Span A");
   SetIndexBuffer(6,SpanB2_Buffer);                                  SetIndexLabel(6,"Senkou Span B");
   
     //
     //
     //
     //
     //
     
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame);
        
         SetIndexShift(2,Kijun        * timeFrame/Period());  
         SetIndexShift(3,Kijun        * timeFrame/Period());  
         SetIndexShift(4,ChinkouShift * timeFrame/Period()); 
         SetIndexShift(5,Kijun        * timeFrame/Period());
         SetIndexShift(6,Kijun        * timeFrame/Period());       
     
     //
     //
     //
     //
     //
     
     IndicatorShortName(timeFrameToString(timeFrame)+"  Ichimoku");
     
return(0);
}

//
//
//
//
//

int deinit() {  return(0);}

//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,r,limit;
   
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars) { Tenkan_Buffer[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
   if (ArrayRange(trends,0)!=Bars) {  ArrayResize(trends,Bars); }
   
       for(i = limit, r=Bars-i-1; i>=0; i--,r++)
       {
       
       double thigh  = High[i];
       double tlow   = Low[i];
       double khigh  = High[i];
       double klow   = Low[i];
       double shigh  = High[i];
       double slow   = Low[i];
       double tprice = 0;
       double kprice = 0;
       double sprice = 0;
       
       //
       //
       //
       //
       //
       
       if (i >= Bars - Tenkan) continue;
       for(k = 0; k < Tenkan; k++)
       {
           tprice = High[i+k];
           if(thigh < tprice) thigh = tprice;
         
           tprice = Low[i+k];
           if(tlow  > tprice) tlow  = tprice;
       }
       
       //
       //
       //
       //
       //
        
       if (i >= Bars - Kijun) continue;
       for(k = 0; k < Kijun; k++)
       {
           kprice = High[i+k];
           if(khigh < kprice) khigh = kprice;
         
           kprice = Low[i+k];
           if(klow  > kprice) klow  = kprice;
       }
       
       //
       //
       //
       //
       //
        
       if (i >= Bars - Senkou) continue;
       for(k = 0; k < Senkou; k++)
       {
           sprice = High[i+k];
           if(shigh < sprice) shigh = sprice;
         
           sprice = Low[i+k];
           if(slow  > sprice) slow  = sprice;
        }
        
        //
        //
        //
        //
        //
        
        Tenkan_Buffer[i]  = iDSmooth((thigh + tlow)/2,             SmoothLength,SmoothPhase,SmoothDouble,i, 0); 
        Kijun_Buffer[i]   = iDSmooth((khigh + klow)/2,             SmoothLength,SmoothPhase,SmoothDouble,i,20);
        SpanA_Buffer[i]   = (Kijun_Buffer[i]+ Tenkan_Buffer[i])/2;
        SpanA2_Buffer[i]  = (Kijun_Buffer[i]+ Tenkan_Buffer[i])/2;
        SpanB_Buffer[i]   = (shigh + slow)/2;             
        SpanB2_Buffer[i]  = (shigh + slow)/2;             
        Chinkou_Buffer[i] = iDSmooth(Close[i],                     SmoothLength,SmoothPhase,SmoothDouble,i,40); 
   
        setTrends(i,r);
              
   }
   
  manageAlerts();
  return(0);
  }
  
  //
  //
  //
  //
  //
   
  limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
  if (ArrayRange(trends,0)!=Bars) ArrayResize(trends,Bars);
      
      
      for(i = limit, r=Bars-i-1; i>=0; i--,r++)
      {
        int y = iBarShift(NULL,timeFrame,Time[i]);
            Tenkan_Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,ChinkouShift,SmoothLength,SmoothPhase,SmoothDouble,0,y);
            Kijun_Buffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,ChinkouShift,SmoothLength,SmoothPhase,SmoothDouble,1,y);
            SpanA_Buffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,ChinkouShift,SmoothLength,SmoothPhase,SmoothDouble,2,y);
            SpanB_Buffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,ChinkouShift,SmoothLength,SmoothPhase,SmoothDouble,3,y);
            Chinkou_Buffer[i]= iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,ChinkouShift,SmoothLength,SmoothPhase,SmoothDouble,4,y);
            SpanA2_Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,ChinkouShift,SmoothLength,SmoothPhase,SmoothDouble,5,y);
            SpanB2_Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Tenkan,Kijun,Senkou,ChinkouShift,SmoothLength,SmoothPhase,SmoothDouble,6,y);
            
            setTrends(i,r);
            
            //
            //
            //
            //
            //
       
            if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
            if (!Interpolate) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int x = 1; x < n; x++)
               {
               
                  Tenkan_Buffer[i+x]  = Tenkan_Buffer[i]  + (Tenkan_Buffer[i+n]  - Tenkan_Buffer[i]) * x/n;
                  Kijun_Buffer[i+x]   = Kijun_Buffer[i]   + (Kijun_Buffer[i+n]   - Kijun_Buffer[i])  * x/n;
                  SpanA_Buffer[i+x]   = SpanA_Buffer[i]   + (SpanA_Buffer[i+n]   - SpanA_Buffer[i])  * x/n;
                  SpanB_Buffer[i+x]   = SpanB_Buffer[i]   + (SpanB_Buffer[i+n]   - SpanB_Buffer[i])  * x/n;
                  Chinkou_Buffer[i+x] = Chinkou_Buffer[i] + (Chinkou_Buffer[i+n] - Chinkou_Buffer[i])* x/n;
                  SpanA2_Buffer[i+x]  = SpanA2_Buffer[i]  + (SpanA2_Buffer[i+n]  - SpanA2_Buffer[i]) * x/n;
                  SpanB2_Buffer[i+x]  = SpanB2_Buffer[i]  + (SpanB2_Buffer[i+n]  - SpanB2_Buffer[i]) * x/n;
                  
               }               
   }

   return(0);
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][60];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//
//
//
//
//

void setTrends(int i, int r)
{
   trends[r][_tmi]  = trends[r-1][_tmi];
   trends[r][_tup1] = trends[r-1][_tup1];
   trends[r][_tup2] = trends[r-1][_tup2];
   trends[r][_tdn1] = trends[r-1][_tdn1];
   trends[r][_tdn2] = trends[r-1][_tdn2];
   
      if (Kijun_Buffer[i]   > Tenkan_Buffer[i])                                         trends[r][_tmi]  =  1;
      if (Kijun_Buffer[i]   < Tenkan_Buffer[i])                                         trends[r][_tmi]  = -1;
      if (Chinkou_Buffer[i] > Close[i])                                                 trends[r][_tdn2] =  1;
      if (Chinkou_Buffer[i] < Close[i])                                                 trends[r][_tdn2] = -1;
      if (Kijun_Buffer[i]   > Tenkan_Buffer[i] && Chinkou_Buffer[i] > Close[i])         trends[r][_tdn1] =  1;
      if (Kijun_Buffer[i]   < Tenkan_Buffer[i] && Chinkou_Buffer[i] < Close[i])         trends[r][_tdn1] = -1;
      if (Kijun_Buffer[i]   > Tenkan_Buffer[i] && Kijun_Buffer[i]   > SpanA2_Buffer[i]) trends[r][_tup2] =  1;
      if (Kijun_Buffer[i]   < Tenkan_Buffer[i] && Kijun_Buffer[i]   < SpanB2_Buffer[i]) trends[r][_tup2] = -1;
      if (Kijun_Buffer[i]   > Tenkan_Buffer[i] && Tenkan_Buffer[i]  > SpanA2_Buffer[i]) trends[r][_tup1] =  1;
      if (Kijun_Buffer[i]   < Tenkan_Buffer[i] && Tenkan_Buffer[i]  < SpanB2_Buffer[i]) trends[r][_tup1] = -1;
}


//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 
                             whichBar = Bars-whichBar-1;

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnTenkanKijunCross && trends[whichBar][_tup1] != trends[whichBar-1][_tup1])
      {
         if (trends[whichBar][_tup1] ==  1) doAlert(time1,mess1,whichBar,"Tenkan Kijun Cross up");
         if (trends[whichBar][_tup1] == -1) doAlert(time1,mess1,whichBar,"Tenkan Kijun Cross down");
      }
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnChinkouPriceCross && trends[whichBar][_tup2] != trends[whichBar-1][_tup2])
      {
         if (trends[whichBar][_tup2] ==  1) doAlert(time2,mess2,whichBar,"Chinkou Cross up");
         if (trends[whichBar][_tup2] == -1) doAlert(time2,mess2,whichBar,"Chinkou Cross down");
      }
      static datetime time3 = 0;
      static string   mess3 = "";
      if (alertsOnBothAboveCross && trends[whichBar][_tdn1] != trends[whichBar-1][_tdn1])
      {
         if (trends[whichBar][_tdn1] ==  1) doAlert(time3,mess3,whichBar,"Tenkan Kijun Chinkou up");
         if (trends[whichBar][_tdn1] == -1) doAlert(time3,mess3,whichBar,"Tenkan Kijun Chinkou down");
      }
      static datetime time4 = 0;
      static string   mess4 = "";
      if (alertsOnKijunKumoCloudCross && trends[whichBar][_tdn2] != trends[whichBar-1][_tdn2])
      {
         if (trends[whichBar][_tdn2] ==  1) doAlert(time4,mess4,whichBar,"Kijun leaving Kumo up");
         if (trends[whichBar][_tdn2] == -1) doAlert(time4,mess4,whichBar,"Kijun leaving Kumo down");
      }
      static datetime time5 = 0;
      static string   mess5 = "";
      if (alertsOnTenkanKumoCloudCross && trends[whichBar][_tmi] != trends[whichBar-1][_tmi])
      {
         if (trends[whichBar][_tmi] ==  1) doAlert(time5,mess5,whichBar,"Tenkan leaving Kumo up");
         if (trends[whichBar][_tmi] == -1) doAlert(time5,mess5,whichBar,"Tenkan leaving Kumo down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Ichimoku smooth ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Ichimoku smooth "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}



